
#include "appevent.ch"
#include "xbp.ch"
#include "gra.ch"
#include "thread.ch"
#include "font.ch"

#include "WORMS.CH"


PROCEDURE AppSys()
RETURN

PROCEDURE main()
LOCAL oDlg, oPS
LOCAL nEvent := NIL, mp1 := NIL, mp2 := NIL, oObj := NIL
LOCAL i            := 1
LOCAL aThreads     := {}
LOCAL aSizeDesktop := AppDesktop():currentSize()
LOCAL nSeconds
LOCAL aRect, nHeight, aSlice
LOCAL aPrios       := { { PRIORITY_LOWEST,  GRA_CLR_RED, .T.  },;
                        { PRIORITY_HIGHEST, GRA_CLR_PINK, .T. },;
                        { PRIORITY_NORMAL,  GRA_CLR_BLUE, .T. } }
LOCAL aTitles      := { "Niedrigste Prioritt", "Hchste Prioritt", ;
                        "Normale Prioritt" }

* ------------------------------ Jimmy ----------------------------------- *
LOCAL aPos  := { 0,0 }
LOCAL aSize := { 0,0 }
LOCAL oStatic, oBitmap

   // Background Bitmap

   oBitmap := XbpBitmap():new():create()
   oBitmap:load( NIL, 100 )
   aSize[1] := oBitmap:xSize
   aSize[2] := oBitmap:ySize

   IF aSize[1]  > aSizeDesktop [1] -100
      aSize[1] := aSizeDesktop [1] -100
   ENDIF
   IF aSize[2]  > aSizeDesktop [2] -100
      aSize[2] := aSizeDesktop [2] -100
   ENDIF
* ------------------------------ Jimmy ----------------------------------- *

    oDlg             := XbpDialog():new( AppDesktop(),, aPos, {0,0},, .T. )
    oDlg:taskList    := .T.
    oDlg:title       := "Worms: Ein Thread-Prioritten Testprogramm!"
    oDlg:border      := XBPDLG_RAISEDBORDERTHICK_FIXED
    oDlg:maxButton   := .F.
    oDlg:minButton   := .T.

* ------------------------------ Jimmy ----------------------------------- *
   // use o:clientSize
   oDlg:clientSize  := aSize

   // avoil flickering
   oDlg:drawingArea:clipChildren := .T.
* ------------------------------ Jimmy ----------------------------------- *

    oDlg:create()
*   oDlg:drawingArea:setColorBG( GRA_CLR_PALEGRAY )

   CenterControl(oDlg)
    SetAppWindow( oDlg )
    SetAppFocus( oDlg )

* ------------------------------ Jimmy ----------------------------------- *
   oStatic := XbpStatic():new( oDlg:drawingArea,,{0,0},oDlg:drawingArea:Currentsize() )
   oStatic:type    := XBPSTATIC_TYPE_BITMAP
   oStatic:caption := oBitmap
   oStatic:create()

*   oPS := SharedPS():new():create( oDlg:drawingArea:winDevice() )
   oPS := SharedPS():new():create( oStatic:winDevice() )
* ------------------------------ Jimmy ----------------------------------- *

    aRect   := oDlg:drawingArea:currentSize()
    nHeight := Abs(aRect[2] / Len(aPrios) )

    aSlice  := {0, aRect[2]-nHeight, aRect[1]-1, aRect[2]-1 }

    nSeconds := Seconds()
    FOR i:= 1 TO Len( aPrios )
       AAdd( aThreads, WormsThread():new( oPS            ,;
                                          aSlice         ,;
                                          ID_BMP_PHASE1  ,;
                                          MAX_PHASES     ,;
                                          oStatic        )) // add oStatic

       aThreads[i]:setStartTime( nSeconds + 2 )
       aThreads[i]:setPriority( aPrios[i][1] )
       aThreads[i]:start( , aTitles[i], aPrios[i][2], aPrios[i][3])

       aSlice[2] -= nHeight
       aSlice[4] -= nHeight
    NEXT

    nEvent := xbe_None
    DO WHILE nEvent != xbeP_Close

        nEvent := AppEvent ( @mp1, @mp2, @oObj, 1 )

        IF nEvent <> xbeP_None .AND. oObj <> NIL
            oObj:handleEvent( nEvent, mp1, mp2 )
        ENDIF

        IF nEvent != xbeP_Close
          nEvent := xbeP_None
        ENDIF
    ENDDO

    AEval( aThreads, {|x,i| x:terminate()} )
    ThreadWaitAll( aThreads )

    i := -1000
    AEval( aThreads, {|x,j| i := x:checkPos(i, @oObj) } )
    oObj:markWinner()

RETURN


CLASS SharedPS FROM XbpPresSpace

EXPORTED:

   SYNC METHOD DrawLine
   SYNC METHOD DrawBox
   SYNC METHOD DrawString
   SYNC METHOD DrawCircle
   SYNC METHOD GetStringBox

ENDCLASS

METHOD SharedPS:DrawLine( aStartPos, aEndPos, aAttrs )
LOCAL aOldAttrs

   IF aAttrs != NIL
      aOldAttrs := GraSetAttrLine( self, aAttrs )
   ENDIF
   GraLine( self, aStartPos, aEndPos )
   IF aAttrs != NIL
      GraSetAttrLine( self, aOldAttrs )
   ENDIF

RETURN self

METHOD SharedPS:DrawBox( aStartPos, aEndPos, aAttrs )
LOCAL aOldAttrs

   IF aAttrs != NIL
      aOldAttrs := GraSetAttrArea( self, aAttrs )
   ENDIF
   GraBox( self, aStartPos, aEndPos )
   IF aAttrs != NIL
      GraSetAttrArea( self, aOldAttrs )
   ENDIF

RETURN self

METHOD SharedPS:DrawString( aPos, cString, aAttrs )
LOCAL aOldAttrs

   IF aAttrs != NIL
      aOldAttrs := GraSetAttrString( self, aAttrs )
   ENDIF
   GraStringAt( self, aPos, cString )
   IF aAttrs != NIL
      GraSetAttrString( self, aOldAttrs )
   ENDIF

RETURN self


METHOD SharedPS:DrawCircle( aPos, nRadius, aAttrs )
LOCAL aOldAttrs

   IF aAttrs != NIL
      aOldAttrs := GraSetAttrLine( self, aAttrs )
   ENDIF
   GraArc( self, aPos, nRadius )
   IF aAttrs != NIL
      GraSetAttrLine( self, aOldAttrs )
   ENDIF

RETURN self



METHOD SharedPS:GetStringBox( cString )
LOCAL aTextBox

   aTextBox := GraQueryTextBox( self, cString )

RETURN aTextBox


CLASS WormsThread FROM Thread
   VAR lTerminateRequest

EXPORTED:
   METHOD init
   METHOD atStart
   METHOD execute
   METHOD markWinner
   METHOD checkPos
   INLINE METHOD terminate
         ::lTerminateRequest := .T.
   RETURN self

PROTECTED:
   VAR oPS

   /* Startposition fr Ausgabe         */
   VAR aStartPos
   /* Aktuelle Position                 */
   VAR aPos
   /* Text, der ausgegeben wird         */
   VAR cString
   /* Farbe fr die Ausgabe des Strings */
   VAR nColor
   /* Ausgabeflche im Parent-Objekt    */
   VAR aOutputArea
   /* Array mit den XbpBitmap-Objekten  */
   /* fr die Ausgabe der einzelnen     */
   /* Animationsphasen                  */
   VAR aAnimPhases
   /* Aktuelle Animationsphase          */
   VAR nCurrAnimPhase
   /* Aktuelle Rundennummer             */
   VAR nCurrLap
   /* Aktuelle Rundennummer ausgeben?   */
   VAR bOutputLap

   METHOD GraSaveScreen()
   METHOD GraRestScreen()

   VAR oParent

ENDCLASS

METHOD WormsThread:init( oPS, aArea, nBaseResID, nMaxPhases, oStatic )
LOCAL i

   ::Thread:init()
   ::oPS               := oPS

   ::aOutputArea       := AClone( aArea )

   ::nCurrAnimPhase    := 1
   ::aAnimPhases       := Array( nMaxPhases )

   FOR i := 1 TO nMaxPhases
     ::aAnimPhases[i] := XbpBitmap():new():create( ::oPS )
     ::aAnimPhases[i]:load( , nBaseResID + (i-1) )

* ------------------------------ Jimmy ----------------------------------- *
   // add transparency
     ::aAnimPhases[i]:TransparentClr := ::aAnimPhases[i]:GetDefaultBGColor()
* ------------------------------ Jimmy ----------------------------------- *

   NEXT

   ::aStartPos         := { aArea[1] - ::aAnimPhases[::nCurrAnimPhase]:xSize, ;
                            aArea[2] + (aArea[4]-aArea[2])/2 }
   ::bOutputLap        := .F.
   ::nCurrLap          := 0
   ::lTerminateRequest := .F.

   ::oParent := oStatic

RETURN self

METHOD WormsThread:atStart( cString, nColor, bLaps )
LOCAL oFont

   ::aPos               := aClone( ::aStartPos )
   ::cString            := cString
   ::nColor             := nColor
   ::bOutputLap         := bLaps

   oFont                := XbpFont():new( ::oPS ):create( "12.Helv" )
   GraSetFont( ::oPS, oFont )

RETURN

METHOD WormsThread:execute()
LOCAL aStringAttrs := Array( GRA_AS_COUNT )
LOCAL aLineAttrs   := Array( GRA_AL_COUNT )
LOCAL aTextBox
LOCAL aStringPos   := Array( 2 )
LOCAL oCurrPhase
LOCAL cTmpString
LOCAL cTmpDBName
LOCAL i
LOCAL aPos,aSize
*LOCAL oBitmap

    FIELD TmpID

    DO WHILE !::lTerminateRequest

        cTmpDBName := "TmpDB" + AllTrim( Str(ThreadID()) ) + ".DBF"
        DbCreate( cTmpDBName, { { "TmpID", "N", 9, 2 } } )

        USE (cTmpDBName) EXCLUSIVE

        FOR i:=1 TO 90
           DBAppend()
           TmpID := i
        NEXT

        SLEEP( 1 )

        DbGoTop()
        FOR i:=1 TO 90
           SKIP
           DBDelete()
        NEXT
        DbPack()

        USE
        ERASE (cTmpDBName)


        ::oPS:DrawLine( {::aPos[1], ::aPos[2]-1 }, {::aPos[1], ::aPos[2]-1 }, NIL )

        oCurrPhase := ::aAnimPhases[::nCurrAnimPhase]

* ------------------------------ Jimmy ----------------------------------- *
      // Save Position and Size

       aPos  := ACLONE(::aPos)
       aSize := { oCurrPhase:xSize, oCurrPhase:ySize }

      // add some more for bigger Rectangle
       aPos[1]  -= 1
       aPos[2]  -= 1
       aSize[1] += 2
       aSize[2] += 2

      // does not work well
*       oBitmap := ::GraSaveScreen(::oPS, aPos, aSize )
* ------------------------------ Jimmy ----------------------------------- *

        oCurrPhase:draw( ::oPS,                             ;
                        {::aPos[1], ::aPos[2],              ;
                         ::aPos[1] + oCurrPhase:xSize,      ;
                         ::aPos[2] + oCurrPhase:ySize} )

        cTmpString      := ::cString
        IF ::bOutputLap == .T.
           cTmpString := ::cString + " (Runde: " + ;
                         AllTrim( Str(::nCurrLap) ) + ")"
        ENDIF

        aTextBox        := ::oPS:GetStringBox( cTmpString )
        aStringPos[1]   := ::aOutputArea[3] - ::aOutputArea[1]
        aStringPos[1]   -= aTextBox[3][1] - aTextBox[1][1]
        aStringPos[1]   := ::aOutputArea[1] + aStringPos[1] /2

        aStringPos[2]   := ::aOutputArea[4]- (aTextBox[3][2] - aTextBox[2][2])

        aStringAttrs[ GRA_AS_COLOR ]     := ::nColor
        aStringAttrs[ GRA_AS_BACKCOLOR ] := GRA_CLR_PALEGRAY
        aStringAttrs[ GRA_AS_BGMIXMODE ] := GRA_BGMIX_OVERPAINT
        ::oPS:DrawString( aStringPos, cTmpString, aStringAttrs )

        ::oPS:DrawBox( {::aOutputArea[1], ::aOutputArea[2]}, ;
                       {::aOutputArea[3], ::aOutputArea[4]}, NIL )

        IF ::nCurrAnimPhase >= MAX_PHASES
            ::aPos[1] += X_VELOCITY
            ::nCurrAnimPhase := 1
        ELSE
            ::nCurrAnimPhase++
        ENDIF

        IF ::aPos[1] - ::aAnimPhases[::nCurrAnimPhase]:xSize > ::aOutputArea[3]
            aLineAttrs[GRA_AL_COLOR] := GRA_CLR_PALEGRAY
            ::oPS:DrawLine( {::aOutputArea[1], ::aStartPos[2]-1}, ;
                            {::aOutputArea[3], ::aStartPos[2]-1}, ;
                            aLineAttrs )
            ::aPos     := AClone( ::aStartPos )
            ::nCurrAnimPhase := 1
            ::nCurrLap++
        ENDIF

* ------------------------------ Jimmy ----------------------------------- *
      SLEEP(2)
      // does not work well
*      ::GraRestScreen(::oPS, aPos, oBitmap )

      // repaint Area

      ::oParent:invalidateRect( {aPos[1] , aPos[2]   ,;
                                 aPos[1] + aSize[1]  ,;
                                 aPos[2] + aSize[2]}    )
* ------------------------------ Jimmy ----------------------------------- *

    ENDDO

RETURN

METHOD WormsThread:markWinner( )
LOCAL i
LOCAL aLineAttrs := Array( GRA_AL_COUNT )

   FOR i:=1 TO 5
       aLineAttrs[GRA_AL_COLOR] := GRA_CLR_BLUE + i
       ::oPS:DrawCircle( {::aPos[1]+20, ::aPos[2]}, 10*i, aLineAttrs )
   NEXT
   Sleep(250)
RETURN

METHOD WormsThread:checkPos( nOthersPos, oSelf )
LOCAL nRetPos := nOthersPos
LOCAL nPos

   nPos := ::nCurrLap * 2000 + ::aPos[1]
   IF nPos > nRetPos
       nRetPos := nPos
       oSelf := self
   ENDIF

RETURN nRetPos

METHOD WormsThread:GraSaveScreen( oSourcePS, aPos, aSize )
LOCAL oBitmap   := XbpBitmap():new():create( oSourcePS )
LOCAL oTargetPS := XbpPresSpace():new():create()
LOCAL aSourceRect[4], aTargetRect

   aSourceRect[1] := aSourceRect[3] := aPos[1]
   aSourceRect[2] := aSourceRect[4] := aPos[2]
   aSourceRect[3] += aSize[1]
   aSourceRect[4] += aSize[2]

   aTargetRect    := {0, 0, aSize[1], aSize[2]}

   oBitmap:presSpace( oTargetPS )
   oBitmap:make( aSize[1], aSize[2] )

   GraBitBlt( oTargetPS, oSourcePS, aTargetRect, aSourceRect )

RETURN oBitmap


METHOD WormsThread:GraRestScreen( oTargetPS, aPos, oBitmap )
   oBitmap:draw( oTargetPS, aPos )
RETURN NIL

